﻿using System;
using System.Windows.Controls;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;


namespace _289938_TreeViewContainerBindings
{
	public class Company : INotifyPropertyChanged
	{
		public Company()
		{
			this.Departments = new ObservableCollection<Department>();
		}

		public MainViewModel MainViewModel { get; set; }

		public string Name { get; set; }
		public ObservableCollection<Department> Departments { get; set; }

		private bool isExpanded;
		public bool IsExpanded
		{
			get
			{
				return isExpanded;
			}
			set
			{
				if (value != isExpanded)
				{
					isExpanded = value;
					OnPropertyChanged("IsExpanded");
				}
			}
		}

		private bool isSelected;
		public bool IsSelected
		{
			get
			{
				return isSelected;
			}
			set
			{
				if (value != isSelected)
				{
					isSelected = value;
					OnPropertyChanged("IsSelected");

					if (isSelected)
						if (this.MainViewModel != null)
							foreach (var company in this.MainViewModel)
								foreach (var dep in company.Departments)
								{
									foreach (var emp in dep.Employees)
									{
										emp.IsSelected = false;
									}

									dep.IsSelected = false;
								}
				}
			}
		}

		#region INotifyPropertyChanged Members

		private void OnPropertyChanged(string propertyName)
		{
			if (PropertyChanged != null)
			{
				PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
			}
		}

		public event PropertyChangedEventHandler PropertyChanged;

		#endregion
	}
}


