﻿using System;
using System.Windows.Controls;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;

namespace _289938_TreeViewContainerBindings
{
	public class Department : INotifyPropertyChanged
	{
		public Department()
		{
			this.Employees = new ObservableCollection<Employee>();
		}
		public Company Company { get; set; }

		public string Name { get; set; }

		private bool isExpanded;
		public bool IsExpanded
		{
			get
			{
				return isExpanded;
			}
			set
			{
				if (value != isExpanded)
				{
					isExpanded = value;
					OnPropertyChanged("IsExpanded");
				}
			}
		}

		private bool isSelected;
		public bool IsSelected
		{
			get
			{
				return isSelected;
			}
			set
			{
				if (value != isSelected)
				{
					isSelected = value;
					OnPropertyChanged("IsSelected");

					if (isSelected)
						if (this.Company != null)
							foreach (var company in this.Company.MainViewModel)
							{
								foreach (var dep in company.Departments)
									foreach (var employee in dep.Employees)
										employee.IsSelected = false;

								company.IsSelected = false;
							}
				}
			}
		}
		public ObservableCollection<Employee> Employees { get; set; }

		#region INotifyPropertyChanged Members
		private void OnPropertyChanged(string PropertyName)
		{
			if (PropertyChanged != null)
			{
				PropertyChanged(this, new PropertyChangedEventArgs(PropertyName));
			}
		}

		public event PropertyChangedEventHandler PropertyChanged;
		#endregion
	}
}
