﻿using System;
using System.Windows.Controls;
using System.Collections.Generic;
using System.ComponentModel;

namespace _289938_TreeViewContainerBindings
{
	public class Employee : INotifyPropertyChanged
	{
		public string Name { get; set; }

		public Department Department { get; set; }

		private bool isExpanded;
		public bool IsExpanded
		{
			get
			{
				return isExpanded;
			}
			set
			{
				if (value != isExpanded)
				{
					isExpanded = value;
					OnPropertyChanged("IsExpanded");
				}
			}
		}

		private bool isSelected;
		public bool IsSelected
		{
			get
			{
				return isSelected;
			}
			set
			{
				if (value != isSelected)
				{
					isSelected = value;
					OnPropertyChanged("IsSelected");

					if (isSelected)
						if (this.Department != null && this.Department.Company != null)
						{
							foreach (var company in this.Department.Company.MainViewModel)
							{
								company.IsSelected = false;

								foreach (var dep in company.Departments)
								{
									dep.IsSelected = false;
								}
							}
						}
				}
			}
		}

		#region INotifyPropertyChanged Members
		private void OnPropertyChanged(string PropertyName)
		{
			if (PropertyChanged != null)
			{
				PropertyChanged(this, new PropertyChangedEventArgs(PropertyName));
			}
		}

		public event PropertyChangedEventHandler PropertyChanged;
		#endregion
	}
}
